## lightspark 0.5.5

=== CMakeLists.txt ===
#**************************************************************************
#    Lightspark, a free flash player implementation
#
#    Copyright (C) 2010-2011  Alessandro Pignotti <a.pignotti@sssup.it>
#    Copyright (C) 2010  Giacomo Spigler <g.spigler@sssup.it>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
#**************************************************************************


CMAKE_MINIMUM_REQUIRED(VERSION 2.6)

# Name & Version
PROJECT(LIGHTSPARK)
SET(MAJOR_VERSION "0")
SET(MINOR_VERSION "5")
SET(PATCH_VERSION "5")
SET(SUBPATCH_VERSION "0")

IF(EXISTS "${CMAKE_SOURCE_DIR}/.git/")
	SET(GIT_VERSION "-git")

	#Find out if we are exactly at a tag. Then the version
	#is enough. Only consider the official release tags like
	#'lightspark-0.5.3'
	EXECUTE_PROCESS(COMMAND git describe --match "lightspark-*" --tags
			WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
			OUTPUT_VARIABLE GIT_DESC
			ERROR_QUIET
			OUTPUT_STRIP_TRAILING_WHITESPACE)
	#Check if that command failed (maybe git is not installed at all)
	IF(GIT_DESC)
		EXECUTE_PROCESS(COMMAND git describe --match "lightspark-*" --tags --abbrev=0
				WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
				OUTPUT_VARIABLE GIT_DESC_ABBREV
				ERROR_QUIET
				OUTPUT_STRIP_TRAILING_WHITESPACE)

		IF(${GIT_DESC} STREQUAL ${GIT_DESC_ABBREV})
			#We are exactly at a tag
			SET(GIT_VERSION "")
		ELSE()
			#Append to GIT_VERSION
			#GIT_DESC_ABBREV is of the form lightspark-0.5.3 (the name of the previous tag)
			#GIT_DESC is of the form lightspark-0.5.3-69-gf49ec56 (tag-numberOfCommits-currentHash)
			#We want GIT_REVISION to be 69-gf49ec56
			#which denotes the number of commits since the last tag (=release)
			#and the current commit's hash
			STRING(REPLACE "${GIT_DESC_ABBREV}-" "" GIT_REVISION "${GIT_DESC}")
			SET(GIT_VERSION "-${GIT_REVISION}")
		ENDIF()
	ENDIF()
ELSE(EXISTS "${CMAKE_SOURCE_DIR}/.git/")
	SET(GIT_VERSION "")
ENDIF(EXISTS "${CMAKE_SOURCE_DIR}/.git/")

IF(SUBPATCH_VERSION EQUAL "0")
	SET(FULLVERSION "${MAJOR_VERSION}.${MINOR_VERSION}.${PATCH_VERSION}${GIT_VERSION}")
ELSE(SUBPATCH_VERSION EQUAL "0")
	SET(FULLVERSION "${MAJOR_VERSION}.${MINOR_VERSION}.${PATCH_VERSION}.${SUBPATCH_VERSION}${GIT_VERSION}")
ENDIF(SUBPATCH_VERSION EQUAL "0")

SET(SHORTVERSION "${MINOR_VERSION}${PATCH_VERSION}${SUBPATCH_VERSION}")

CONFIGURE_FILE("${CMAKE_SOURCE_DIR}/src/version.h.in" "${CMAKE_CURRENT_BINARY_DIR}/version.h" @ONLY)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})

# GCC 4.4+ is required, GCC_VERSION macro taken from GCC manual
INCLUDE(CheckCSourceCompiles)
IF(CMAKE_COMPILER_IS_GNUCC)
   CHECK_C_SOURCE_COMPILES("
   #define GCC_VERSION (__GNUC__ * 10000 + __GNUC_MINOR__ * 100 + __GNUC_PATCHLEVEL__)
   #if GCC_VERSION < 40400
   #error
   #endif
   int main() { return 0; }" GCC_IS_4_4)
   IF(NOT GCC_IS_4_4)
	  MESSAGE(FATAL_ERROR "GCC 4.4+ is required.")
   ENDIF(NOT GCC_IS_4_4)
ENDIF(CMAKE_COMPILER_IS_GNUCC)

# Find put the path of the gnash executable, if available
FIND_PROGRAM(GNASH_EXE_PATH NAMES gnash)

IF(GNASH_EXE_PATH)
	MESSAGE(STATUS "Found gnash path: ${GNASH_EXE_PATH}")
ELSE(GNASH_EXE_PATH)
# Set a default path
	MESSAGE(STATUS "Gnash not found")
	SET(GNASH_EXE_PATH "/usr/bin/gnash")
ENDIF(GNASH_EXE_PATH)

# Find out CPU architecture ...
# we could also use IF(CMAKE_SIZEOF_VOID_P EQUAL 4) to determine if it's a 32 or a 64bit arch
#
# Setting the value of LIB_SUFFIX if not specified (We could build 32bit version on 64bit)
# However, some distro don't implement FHS the same way
# Suse, Redhat put 64bit libs in /lib64; Debian use /lib for 64bit, but specifies /lib32 for 32bit libs
# See FHS 2.3 for Lib directories under each architecture 

# Some directory shortcuts
SET(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/conf)
INCLUDE(Pack)
# If we're gcc, then use nasm to get fastpath.  If MSVC, just use inline asm to get around
# CMake issues 
IF(CMAKE_COMPILER_IS_GNUCC)
   INCLUDE(CMakeASM-NASMCompiler)
ENDIF(CMAKE_COMPILER_IS_GNUCC)
IF(${CMAKE_SYSTEM_PROCESSOR} MATCHES "^i[3-6]86$|^x86$")
	SET(i386 1)
	SET(LIB_SUFFIX "" CACHE STRING "Choose the suffix of the lib folder (if any) : None 32")
	# nasm for assembly optimizations
	IF(CMAKE_COMPILER_IS_GNUCC)
	   ENABLE_LANGUAGE(ASM-NASM)        
	ENDIF(CMAKE_COMPILER_IS_GNUCC)
ELSEIF(${CMAKE_SYSTEM_PROCESSOR} MATCHES "unknown" AND ${CMAKE_SYSTEM} MATCHES "GNU-0.3")
	# GNU Hurd is i386
	SET(i386 1)
	SET(LIB_SUFFIX "" CACHE STRING "Choose the suffix of the lib folder (if any) : None 32")
	# nasm for assembly optimizations
	IF(CMAKE_COMPILER_IS_GNUCC)
	   ENABLE_LANGUAGE(ASM-NASM)
	ENDIF ()
ELSEIF(${CMAKE_SYSTEM_PROCESSOR} MATCHES "^x86_64$|^amd64$")
	SET(x86_64 1)
	SET(LIB_SUFFIX "" CACHE STRING "Choose the suffix of the lib folder (if any) : None 64")
	# nasm for assembly optimizations
	IF(CMAKE_COMPILER_IS_GNUCC)
	  ENABLE_LANGUAGE(ASM-NASM)
	ENDIF(CMAKE_COMPILER_IS_GNUCC)
ELSEIF(${CMAKE_SYSTEM_PROCESSOR} MATCHES "ppc")
	SET(ppc 1)
	SET(LIB_SUFFIX "" CACHE STRING "Choose the suffix of the lib folder (if any) : None ppc")
	SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -maltivec -D__STDC_CONSTANT_MACROS -fPIC")
ELSE(${CMAKE_SYSTEM_PROCESSOR} MATCHES "^i[3-6]86$|^x86$")
	# All non-x86 non-ppc architectures.
	SET(LIB_SUFFIX "" CACHE STRING "Choose the suffix of the lib folder (if any) : None")
ENDIF(${CMAKE_SYSTEM_PROCESSOR} MATCHES "^i[3-6]86$|^x86$")

IF(CMAKE_SYSTEM_NAME STREQUAL CMAKE_HOST_SYSTEM_NAME)
  SET(CROSSCOMPILING FALSE)
ELSE()
  SET(CROSSCOMPILING TRUE)
ENDIF()

#On mingw-cross-env, all depedencies are static libs
IF(CROSSCOMPILING AND MINGW)
  SET(STATICDEPS TRUE)
ELSE()
  SET(STATICDEPS FALSE)
ENDIF()

# Using relative folders, cmake happens by itself CMAKE_INSTALL_PREFIX
IF(UNIX)
   SET(ETCDIR "/etc") #Using absolute folder
   SET(BINDIR "bin")
   SET(DATADIR "share")
   # Absolute path, because this path is embedded in the binary
   SET(LSDATADIR "${CMAKE_INSTALL_PREFIX}/${DATADIR}/lightspark")
   SET(LIBDIR "lib${LIB_SUFFIX}")
   #We need a absolute path here because we use it for rpath
   #later on
   SET(PRIVATELIBDIR "${CMAKE_INSTALL_PREFIX}/${LIBDIR}/lightspark")
   SET(CMAKE_INSTALL_RPATH "${PRIVATELIBDIR}")
   SET(PLUGINSDIR "${PRIVATELIBDIR}/plugins")
ELSE()
  SET(ETCDIR ".")
  SET(BINDIR ".")
  SET(DATADIR ".")
  SET(LSDATADIR ".")
  SET(LIBDIR ".")
  SET(PRIVATELIBDIR ".")
  SET(PLUGINSDIR ".")
ENDIF(UNIX)

# Setting variables
IF(WIN32)
  SET(AUDIO_BACKEND "winmm" CACHE STRING "Which audio backends should be built?")
ELSE()
  SET(AUDIO_BACKEND "pulseaudio" CACHE STRING "Which audio backends should be built?")
ENDIF()

SET(CMAKE_INSTALL_PREFIX "/usr/local" CACHE PATH "Install prefix, default is /usr/local (UNIX) and C:\\Program Files (Windows)")
SET(COMPILE_LIGHTSPARK TRUE CACHE BOOL "Compile Lightspark?")
SET(COMPILE_TIGHTSPARK TRUE CACHE BOOL "Compile Tightspark?")
SET(COMPILE_PLUGIN TRUE CACHE BOOL "Compile the browser plugin?")
SET(ENABLE_CURL TRUE CACHE BOOL "Enable CURL? (Required for Downloader functionality)")
SET(ENABLE_GLES2 FALSE CACHE BOOL "Build with OpenGLES 2.0 support instead of OpenGL")
SET(ENABLE_LIBAVCODEC TRUE CACHE BOOL "Enable libavcodec and dependent functionality?")
SET(ENABLE_RTMP FALSE CACHE BOOL "Enable librtmp and dependent functionality?")
SET(ENABLE_PROFILING FALSE CACHE BOOL "Enable profiling support? (Causes performance issues)")
SET(PLUGIN_DIRECTORY "${LIBDIR}/mozilla/plugins" CACHE STRING "Directory to install Firefox plugin to")

IF(ENABLE_DEBIAN_ALTERNATIVES OR WIN32)
  SET(PLUGIN_DIRECTORY ${PRIVATELIBDIR})
ENDIF()

IF(NOT CMAKE_BUILD_TYPE)
	SET(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING
		"Choose the type of build, options are: Debug Release RelWithDebInfo Profile" FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

# The library is searched in its private library directory
SET(CMAKE_SKIP_BUILD_RPATH FALSE)
SET(CMAKE_INSTALL_RPATH "${PRIVATELIBDIR}")

# Libraries we need
INCLUDE(FindPkgConfig REQUIRED)
INCLUDE(FindGettext REQUIRED)
INCLUDE(FindLLVM REQUIRED)
IF(${LLVM_STRING_VERSION} VERSION_LESS 2.8)
	MESSAGE(FATAL_ERROR "LLVM >=2.8 is required!")
ENDIF(${LLVM_STRING_VERSION} VERSION_LESS 2.8)
IF(${LLVM_STRING_VERSION} VERSION_EQUAL 2.9)
	MESSAGE(FATAL_ERROR "LLVM !=2.9 is required!")
ENDIF(${LLVM_STRING_VERSION} VERSION_EQUAL 2.9)
IF(${LLVM_STRING_VERSION} VERSION_EQUAL 2.8)
	ADD_DEFINITIONS(-DLLVM_28)
ENDIF(${LLVM_STRING_VERSION} VERSION_EQUAL 2.8)
IF(${LLVM_STRING_VERSION} VERSION_GREATER 2.9)
	ADD_DEFINITIONS(-DLLVM_3)
ENDIF(${LLVM_STRING_VERSION} VERSION_GREATER 2.9)
INCLUDE(FindZLIB REQUIRED)
INCLUDE(FindFreetype REQUIRED)
IF(NOT(ENABLE_GLES2))
INCLUDE(FindOpenGL REQUIRED)
INCLUDE(FindGLEW REQUIRED)
ENDIF(NOT(ENABLE_GLES2))
INCLUDE(FindPCRE REQUIRED)
INCLUDE(FindJPEG REQUIRED)
pkg_check_modules(XMLPP REQUIRED libxml++-2.6>=2.33.1)

find_package(Boost COMPONENTS filesystem system REQUIRED)
if(Boost_FOUND)
  INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIRS})
ENDIF(Boost_FOUND) 

pkg_check_modules(CAIRO_LIBS REQUIRED cairo pangocairo)

IF(UNIX)
  pkg_check_modules(X11 REQUIRED x11)
  INCLUDE_DIRECTORIES(${X11_INCLUDE_DIRS})
ENDIF(UNIX)

IF(ENABLE_GLES2)
  pkg_check_modules(GLES2 REQUIRED egl glesv2)
  ADD_DEFINITIONS(-DENABLE_GLES2)
ENDIF(ENABLE_GLES2)

IF(WIN32)
  SET(EXTRA_LIBS_LIBRARIES ${EXTRA_LIBS_LIBRARIES} ws2_32.lib imagehlp.lib)
ENDIF(WIN32)

IF(AUDIO_BACKEND)
  ADD_DEFINITIONS(-DAUDIO_BACKEND="${AUDIO_BACKEND}")
ENDIF(AUDIO_BACKEND)

IF(ENABLE_LIBAVCODEC)
	pkg_check_modules(FFMPEG libavcodec libavutil libavformat)
	IF(NOT(FFMPEG_FOUND))
		INCLUDE(FindFFMpeg REQUIRED)
	ENDIF(NOT(FFMPEG_FOUND))
	# Compatibility checks for ffmpeg deprecated functions
  INCLUDE(CheckFunctionExists REQUIRED)
  SET(CMAKE_REQUIRED_FLAGS ${LIBAVCODEC_CFLAGS})
  SET(CMAKE_REQUIRED_INCLUDES ${FFMPEG_INCLUDE_DIRS})
  SET(CMAKE_REQUIRED_LIBRARIES ${FFMPEG_LIBRARIES})
  CHECK_FUNCTION_EXISTS(avcodec_decode_video2 HAVE_AVCODEC_DECODE_VIDEO2)
  CHECK_FUNCTION_EXISTS(avcodec_decode_audio3 HAVE_AVCODEC_DECODE_AUDIO3)
  SET(CMAKE_REQUIRED_FLAGS)
  SET(CMAKE_REQUIRED_INCLUDES)
  SET(CMAKE_REQUIRED_LIBRARIES)
  IF(HAVE_AVCODEC_DECODE_VIDEO2)
    ADD_DEFINITIONS(-DHAVE_AVCODEC_DECODE_VIDEO2)
  ENDIF(HAVE_AVCODEC_DECODE_VIDEO2)
  IF(HAVE_AVCODEC_DECODE_AUDIO3)
    ADD_DEFINITIONS(-DHAVE_AVCODEC_DECODE_AUDIO3)
  ENDIF(HAVE_AVCODEC_DECODE_AUDIO3)
  ADD_DEFINITIONS(-DENABLE_LIBAVCODEC)
ENDIF(ENABLE_LIBAVCODEC)

pkg_check_modules(GLIB REQUIRED glib-2.0)
pkg_check_modules(GTHREAD REQUIRED gthread-2.0)
pkg_check_modules(GMODULE REQUIRED gmodule-2.0)
pkg_check_modules(GLIBMM REQUIRED glibmm-2.4)
INCLUDE_DIRECTORIES(${GLIBMM_INCLUDE_DIRS})
pkg_check_modules(GTK REQUIRED gtk+-2.0)

INCLUDE_DIRECTORIES(${LLVM_INCLUDE_DIR})
INCLUDE_DIRECTORIES(${ZLIB_INCLUDE_DIR})
INCLUDE_DIRECTORIES(${FREETYPE_INCLUDE_DIRS})
IF(ENABLE_GLES2)
	INCLUDE_DIRECTORIES(${GLES2_INCLUDE_DIRS})
ELSE()
	INCLUDE_DIRECTORIES(${OPENGL_INCLUDE_DIR})
	INCLUDE_DIRECTORIES(${GLEW_INCLUDE_DIR})
ENDIF(ENABLE_GLES2)
INCLUDE_DIRECTORIES(${PCRE_INCLUDE_DIR})
INCLUDE_DIRECTORIES(${JPEG_INCLUDE_DIR})
INCLUDE_DIRECTORIES(${XMLPP_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${CAIRO_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${GLIB_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${GTK_INCLUDE_DIRS})

IF(ENABLE_LIBAVCODEC)
  INCLUDE_DIRECTORIES(${FFMPEG_INCLUDE_DIRS})
  SET(OPTIONAL_LIBRARIES ${OPTIONAL_LIBRARIES} ${FFMPEG_LIBRARIES})
ENDIF(ENABLE_LIBAVCODEC)	

IF(CMAKE_COMPILER_IS_GNUCC)
  IF(MINGW)

=== src/CMakeLists.txt ===
#**************************************************************************
#    Lightspark, a free flash player implementation
#
#    Copyright (C) 2010-2011  Alessandro Pignotti <a.pignotti@sssup.it>
#    Copyright (C) 2010  Giacomo Spigler <g.spigler@sssup.it>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
#**************************************************************************

# liblightspark.so sources
SET(LIBSPARK_SOURCES 
  asobject.cpp
  compat.cpp
  logger.cpp
  swf.cpp
  swftypes.cpp
  thread_pool.cpp
  threading.cpp
  timer.cpp
  backends/audio.cpp
  backends/builtindecoder.cpp
  backends/config.cpp
  backends/decoder.cpp
  backends/extscriptobject.cpp
  backends/geometry.cpp
  backends/graphics.cpp
  backends/image.cpp
  backends/input.cpp
  backends/netutils.cpp
  backends/pluginmanager.cpp
  backends/rendering.cpp
  backends/rendering_context.cpp
  backends/rtmputils.cpp
  backends/security.cpp
  backends/urlutils.cpp
  parsing/amf3_generator.cpp
  parsing/config.cpp
  parsing/crossdomainpolicy.cpp
  parsing/flv.cpp
  parsing/streams.cpp
  parsing/tags.cpp
  parsing/tags_stub.cpp
  parsing/textfile.cpp
  scripting/abc.cpp
  scripting/abc_codesynt.cpp
  scripting/abc_interpreter.cpp
  scripting/abc_opcodes.cpp
  scripting/abctypes.cpp
  scripting/flash/accessibility/flashaccessibility.cpp
  scripting/flash/display/flashdisplay.cpp
  scripting/flash/events/flashevents.cpp
  scripting/flash/external/ExternalInterface.cpp
  scripting/flash/filters/flashfilters.cpp
  scripting/flash/geom/flashgeom.cpp
  scripting/flash/media/flashmedia.cpp
  scripting/flash/net/flashnet.cpp
  scripting/flash/net/URLStream.cpp
  scripting/flash/errors/flasherrors.cpp
  scripting/flash/sensors/flashsensors.cpp
  scripting/flash/system/flashsystem.cpp
  scripting/flash/text/flashtext.cpp
  scripting/flash/utils/flashutils.cpp
  scripting/flash/xml/flashxml.cpp
  scripting/toplevel/Array.cpp
  scripting/toplevel/ASString.cpp
  scripting/toplevel/Boolean.cpp
  scripting/toplevel/Date.cpp
  scripting/toplevel/Error.cpp
  scripting/toplevel/Math.cpp
  scripting/toplevel/Vector.cpp
  scripting/toplevel/XML.cpp
  scripting/toplevel/XMLList.cpp
  scripting/class.cpp
  scripting/toplevel/toplevel.cpp
  platforms/engineutils.cpp)
IF(MINGW)
  SET(LIBSPARK_SOURCES ${LIBSPARK_SOURCES} platforms/slowpaths_generic.cpp)
ELSE()
  IF(${i386})
    SET(LIBSPARK_SOURCES ${LIBSPARK_SOURCES} platforms/fastpaths_x86.cpp)
    SET(LIBSPARK_SOURCES ${LIBSPARK_SOURCES} platforms/fastpaths_i686.asm)
  ELSEIF(${x86_64})
    SET(LIBSPARK_SOURCES ${LIBSPARK_SOURCES} platforms/fastpaths_x86.cpp)
    SET(LIBSPARK_SOURCES ${LIBSPARK_SOURCES} platforms/fastpaths_amd64.asm)
  ELSE()
    SET(LIBSPARK_SOURCES ${LIBSPARK_SOURCES} platforms/slowpaths_generic.cpp)
  ENDIF(${i386})
ENDIF(MINGW)

INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/src)
INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/src/scripting)

# liblightspark.so target
IF(CMAKE_COMPILER_IS_GNUCC)
  ADD_LIBRARY(spark SHARED ${LIBSPARK_SOURCES})
  IF(NOT WIN32)
    #win32's cmake doesn't like liblightspark and lightspark.exe having the same name
    SET_TARGET_PROPERTIES(spark PROPERTIES OUTPUT_NAME lightspark)
  ENDIF()
  IF(MINGW)
    SET_TARGET_PROPERTIES(spark PROPERTIES LINK_FLAGS "-Wl,--export-all-symbols")
  ELSE()
    SET_TARGET_PROPERTIES(spark PROPERTIES LINK_FLAGS "-Wl,--version-script=${PROJECT_SOURCE_DIR}/src/lightspark.expmap")
  ENDIF()
  SET_TARGET_PROPERTIES(spark PROPERTIES LINK_INTERFACE_LIBRARIES "")
ELSE (CMAKE_COMPILER_IS_GNUCC)
  ADD_LIBRARY(spark STATIC ${LIBSPARK_SOURCES})
ENDIF (CMAKE_COMPILER_IS_GNUCC)

TARGET_LINK_LIBRARIES(spark ${CAIRO_LIBRARIES} ${ZLIB_LIBRARIES}
	${Boost_LIBRARIES} ${LLVM_LIBS_CORE} ${LLVM_LIBS_JIT} ${LLVM_LDFLAGS}
	${OPTIONAL_LIBRARIES} ${GTK_LIBRARIES} ${FREETYPE_LIBRARIES} ${JPEG_LIBRARIES}
	${PCRE_LIBRARIES} ${GLIBMM_LIBRARIES} ${GMODULE_LIBRARIES}
	${XMLPP_LIBRARIES} ${CMAKE_DL_LIBS} ${EXTRA_LIBS_LIBRARIES}
	${X11_LIBRARIES})
SET_TARGET_PROPERTIES(spark PROPERTIES VERSION "${MAJOR_VERSION}.${MINOR_VERSION}.${PATCH_VERSION}")
SET_TARGET_PROPERTIES(spark PROPERTIES SOVERSION "${MAJOR_VERSION}.${MINOR_VERSION}")

IF(ENABLE_GLES2)
	TARGET_LINK_LIBRARIES(spark ${GLES2_LIBRARIES})
ELSE()
	TARGET_LINK_LIBRARIES(spark ${OPENGL_LIBRARIES} ${GLEW_LIBRARIES})
ENDIF(ENABLE_GLES2)

PACK_LIBRARY(spark)
#We have to use LIBRARY on linux and RUNTIME on win32
INSTALL(TARGETS spark RUNTIME DESTINATION ${PRIVATELIBDIR} LIBRARY DESTINATION ${PRIVATELIBDIR})

# lightspark executable target
IF(COMPILE_LIGHTSPARK)
  ADD_EXECUTABLE(lightspark main.cpp)
  TARGET_LINK_LIBRARIES(lightspark spark)
  #With STATICDEPS, all deps are compiled into spark
  IF(NOT STATICDEPS)
    TARGET_LINK_LIBRARIES(lightspark ${Boost_LIBRARIES} ${X11_LIBRARIES} ${GTK_LIBRARIES} ${GLIBMM_LIBRARIES} ${GTHREAD_LIBRARIES})
  ENDIF()

  PACK_EXECUTABLE(lightspark)
  INSTALL(FILES ${PROJECT_SOURCE_DIR}/src/lightspark.frag DESTINATION ${LSDATADIR})
  INSTALL(FILES ${PROJECT_SOURCE_DIR}/src/lightspark.vert DESTINATION ${LSDATADIR})
  INSTALL(FILES ${PROJECT_SOURCE_DIR}/src/lightspark-blitter.vert DESTINATION ${LSDATADIR})
  INSTALL(TARGETS lightspark RUNTIME DESTINATION ${BINDIR})
  IF(UNIX)
    INSTALL(FILES ${PROJECT_SOURCE_DIR}/docs/man/lightspark.1 DESTINATION share/man/man1)
  ENDIF(UNIX)
ENDIF(COMPILE_LIGHTSPARK)

# tightspark executable target
IF(COMPILE_TIGHTSPARK)
  ADD_EXECUTABLE(tightspark tightspark.cpp)
  TARGET_LINK_LIBRARIES(tightspark spark)
  #With STATICDEPS, all deps are compiled into spark
  IF(NOT STATICDEPS)
    TARGET_LINK_LIBRARIES(tightspark ${Boost_LIBRARIES} ${GLIBMM_LIBRARIES} ${GTHREAD_LIBRARIES})
  ENDIF()

  INSTALL(TARGETS tightspark RUNTIME DESTINATION ${BINDIR})
  PACK_EXECUTABLE(tightspark)
ENDIF(COMPILE_TIGHTSPARK)

# Browser plugin
IF(COMPILE_PLUGIN)
  ADD_SUBDIRECTORY(plugin)
ENDIF(COMPILE_PLUGIN)

ADD_SUBDIRECTORY(backends/interfaces)

=== debian/changelog ===
lightspark (0.5.5-1+gles2~exp0) experimental; urgency=low

  * Build lightspark against gles2 libraries, upload to experimental.

 -- Didier Raboud <odyx@debian.org>  Wed, 14 Mar 2012 10:02:23 +0100

lightspark (0.5.5-1) unstable; urgency=low

  * New 0.5.5 upstream release
  * Bugfix debian/watch to recognize https downloads.

 -- Didier Raboud <odyx@debian.org>  Tue, 13 Mar 2012 13:59:16 +0100

lightspark (0.5.4.1-1+gles2~exp0) experimental; urgency=low

  * Build lightspark against gles2 libraries, upload to experimental.

 -- Didier Raboud <odyx@debian.org>  Thu, 02 Feb 2012 10:28:36 +0100

lightspark (0.5.4-1+gles2~exp0) experimental; urgency=low

  * Build lightspark against gles2 libraries, upload to experimental.

 -- Didier Raboud <odyx@debian.org>  Tue, 31 Jan 2012 19:27:46 +0100

lightspark (0.5.3-2+gles2~exp0) experimental; urgency=low

  * Build lightspark against gles2 libraries, upload to experimental.

 -- Didier Raboud <odyx@debian.org>  Mon, 02 Jan 2012 20:18:59 +0100

lightspark (0.5.3-1+gles2~exp0) experimental; urgency=low

  * Build lightspark against gles2 libraries, upload to experimental.

 -- Didier Raboud <odyx@debian.org>  Fri, 09 Dec 2011 11:27:18 +0100

=== debian/control ===
Source: lightspark
Section: utils
Priority: optional
Maintainer: Debian Flash Maintainers <pkg-flash-devel@lists.alioth.debian.org>
Uploaders: Didier Raboud <odyx@debian.org>
Build-Depends: debhelper (>= 8.9.0~),
  cmake,
  nasm,
  llvm-3.0-dev,
  libcurl4-gnutls-dev,
  zlib1g-dev,
  libgles2-mesa-dev,
  libpcre3-dev,
  libavutil-dev,
  libx11-dev,
  libglu1-mesa-dev,
  libglew-dev,
  libboost-filesystem-dev,
  libboost-system-dev,
  libboost-regex-dev,
  libpulse-dev,
  libavcodec-dev,
  libavformat-dev,
  libgtk2.0-dev,
  libjpeg-dev,
  librtmp-dev,
  libsdl1.2-dev,
  libxml++2.6-dev (>= 2.33.1),
Standards-Version: 3.9.2
Homepage: http://lightspark.sf.net
Vcs-Git: git://git.debian.org/pkg-flash/lightspark.git
Vcs-Browser: http://git.debian.org/?p=pkg-flash/lightspark.git

Package: lightspark
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: gnash
Description: High-performance SWF player (experimental)
 Lightspark is a free Flash player for Linux which aims for high-performance
 by using modern technologies such as JIT compilation and OpenGL shaders.
 .
 The project is currently in an alpha status and provides the standalone
 player and browser plugin for testing purposes only.
 .
 Nice features:
  * JIT compilation of ActionScript to native x86 bytecode
  * Hardware accelerated rendering using OpenGL shaders (GLSL)
  * Aims to support current-generation ActionScript 3
  * A new, clean, codebase exploiting multithreading and optimized for modern
    hardware. Designed from scratch after the official Flash documentation was
    released.

Package: browser-plugin-lightspark
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: gnash-common
Description: High-performance SWF player - Mozilla Plugin (experimental)
 Lightspark is a free Flash player for Linux which aims for high-performance
 by using modern technologies such as JIT compilation and OpenGL shaders.
 .
 The project is currently in an alpha status and provides the standalone
 player and browser plugin for testing purposes only.
 .
 Nice features:
  * JIT compilation of ActionScript to native x86 bytecode
  * Hardware accelerated rendering using OpenGL shaders (GLSL)
  * Aims to support current-generation ActionScript 3
  * A new, clean, codebase exploiting multithreading and optimized for modern
    hardware. Designed from scratch after the official Flash documentation was
    released.
 .
 This package contains the browser plugin.

Package: lightspark-common
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ttf-liberation
Recommends: pulseaudio
Description: High-performance SWF player - common data
 Lightspark is a free Flash player for Linux which aims for high-performance
 by using modern technologies such as JIT compilation and OpenGL shaders.
 .
 The project is currently in an alpha status and provides the standalone
 player and mozilla plugin for testing purposes only.
 .
 Nice features:
  * JIT compilation of ActionScript to native x86 bytecode
  * Hardware accelerated rendering using OpenGL shaders (GLSL)
  * Aims to support current-generation ActionScript 3
  * A new, clean, codebase exploiting multithreading and optimized for modern
    hardware. Designed from scratch after the official Flash documentation was
    released.
 .
 This package contains the common library and data.

Package: lightspark-dbg
Section: debug
Priority: extra
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, 
 lightspark (= ${binary:Version}) |
 browser-plugin-lightspark (= ${binary:Version}) |
 lightspark-common (= ${binary:Version})
Description: High-performance SWF player (experimental) - Debug symbols
 Lightspark is a free Flash player for Linux which aims for high-performance
 by using modern technologies such as JIT compilation and OpenGL shaders.
 .
 The project is currently in an alpha status and provides the standalone
 player and browser plugin for testing purposes only.
 .
 Nice features:
  * JIT compilation of ActionScript to native x86 bytecode
  * Hardware accelerated rendering using OpenGL shaders (GLSL)
  * Aims to support current-generation ActionScript 3
  * A new, clean, codebase exploiting multithreading and optimized for modern
    hardware. Designed from scratch after the official Flash documentation was
    released.
 .
 This package contains the debug symbols.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- \
	    -DENABLE_GLES2=1 \
	    -DAUDIO_BACKEND="pulse sdl"

override_dh_strip:
	dh_strip --dbg-package=lightspark-dbg

override_dh_install:
	dh_install --list-missing

override_dh_shlibdeps:
	export LD_LIBRARY_PATH="$(CURDIR)/debian/lightspark-common/usr/lib/lightspark:$$LD_LIBRARY_PATH" ; \
	    dh_shlibdeps -Llightspark-common \
	    -pbrowser-plugin-lightspark -plightspark \
	    -- -Ldebian/common.shlibs
	
	dh_shlibdeps --remaining-packages

override_dh_makeshlibs:
	dh_makeshlibs -X/usr/lib/lightspark

## lightspark 0.6.0.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #**************************************************************************
 #    Lightspark, a free flash player implementation
 #
-#    Copyright (C) 2010-2011  Alessandro Pignotti <a.pignotti@sssup.it>
+#    Copyright (C) 2010-2012  Alessandro Pignotti <a.pignotti@sssup.it>
 #    Copyright (C) 2010  Giacomo Spigler <g.spigler@sssup.it>
 #
 #    This program is free software: you can redistribute it and/or modify
@@ -24,9 +24,9 @@
 # Name & Version
 PROJECT(LIGHTSPARK)
 SET(MAJOR_VERSION "0")
-SET(MINOR_VERSION "5")
-SET(PATCH_VERSION "5")
-SET(SUBPATCH_VERSION "0")
+SET(MINOR_VERSION "6")
+SET(PATCH_VERSION "0")
+SET(SUBPATCH_VERSION "1")
 
 IF(EXISTS "${CMAKE_SOURCE_DIR}/.git/")
 	SET(GIT_VERSION "-git")
@@ -198,8 +198,9 @@
 SET(ENABLE_CURL TRUE CACHE BOOL "Enable CURL? (Required for Downloader functionality)")
 SET(ENABLE_GLES2 FALSE CACHE BOOL "Build with OpenGLES 2.0 support instead of OpenGL")
 SET(ENABLE_LIBAVCODEC TRUE CACHE BOOL "Enable libavcodec and dependent functionality?")
-SET(ENABLE_RTMP FALSE CACHE BOOL "Enable librtmp and dependent functionality?")
+SET(ENABLE_RTMP TRUE CACHE BOOL "Enable librtmp and dependent functionality?")
 SET(ENABLE_PROFILING FALSE CACHE BOOL "Enable profiling support? (Causes performance issues)")
+SET(ENABLE_MEMORY_USAGE_PROFILING FALSE CACHE BOOL "Enable profiling of memory usage? (Causes performance issues)")
 SET(PLUGIN_DIRECTORY "${LIBDIR}/mozilla/plugins" CACHE STRING "Directory to install Firefox plugin to")
 
 IF(ENABLE_DEBIAN_ALTERNATIVES OR WIN32)
@@ -228,9 +229,12 @@
 IF(${LLVM_STRING_VERSION} VERSION_EQUAL 2.8)
 	ADD_DEFINITIONS(-DLLVM_28)
 ENDIF(${LLVM_STRING_VERSION} VERSION_EQUAL 2.8)
-IF(${LLVM_STRING_VERSION} VERSION_GREATER 2.9)
-	ADD_DEFINITIONS(-DLLVM_3)
-ENDIF(${LLVM_STRING_VERSION} VERSION_GREATER 2.9)
+IF(${LLVM_STRING_VERSION} VERSION_EQUAL 3.0)
+	ADD_DEFINITIONS(-DLLVM_30)
+ENDIF(${LLVM_STRING_VERSION} VERSION_EQUAL 3.0)
+IF(${LLVM_STRING_VERSION} VERSION_GREATER 3.0)
+	ADD_DEFINITIONS(-DLLVM_31)
+ENDIF(${LLVM_STRING_VERSION} VERSION_GREATER 3.0)
 INCLUDE(FindZLIB REQUIRED)
 INCLUDE(FindFreetype REQUIRED)
 IF(NOT(ENABLE_GLES2))
@@ -239,14 +243,19 @@
 ENDIF(NOT(ENABLE_GLES2))
 INCLUDE(FindPCRE REQUIRED)
 INCLUDE(FindJPEG REQUIRED)
+INCLUDE(FindPNG REQUIRED)
 pkg_check_modules(XMLPP REQUIRED libxml++-2.6>=2.33.1)
+
+IF(XMLPP_FOUND AND NOT(XMLPP_VERSION VERSION_LESS 2.35.1))
+  ADD_DEFINITIONS(-DXMLPP_2_35_1)
+ENDIF(XMLPP_FOUND AND NOT(XMLPP_VERSION VERSION_LESS 2.35.1))
 
 find_package(Boost COMPONENTS filesystem system REQUIRED)
 if(Boost_FOUND)
   INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIRS})
 ENDIF(Boost_FOUND) 
 
-pkg_check_modules(CAIRO_LIBS REQUIRED cairo pangocairo)
+pkg_check_modules(CAIRO REQUIRED cairo pangocairo)
 
 IF(UNIX)
   pkg_check_modules(X11 REQUIRED x11)
@@ -278,6 +287,8 @@
   SET(CMAKE_REQUIRED_LIBRARIES ${FFMPEG_LIBRARIES})
   CHECK_FUNCTION_EXISTS(avcodec_decode_video2 HAVE_AVCODEC_DECODE_VIDEO2)
   CHECK_FUNCTION_EXISTS(avcodec_decode_audio3 HAVE_AVCODEC_DECODE_AUDIO3)
+  CHECK_FUNCTION_EXISTS(avcodec_decode_audio4 HAVE_AVCODEC_DECODE_AUDIO4)
+  CHECK_FUNCTION_EXISTS(avio_alloc_context HAVE_AVIO_ALLOC_CONTEXT)
   SET(CMAKE_REQUIRED_FLAGS)
   SET(CMAKE_REQUIRED_INCLUDES)
   SET(CMAKE_REQUIRED_LIBRARIES)
@@ -287,6 +298,12 @@
   IF(HAVE_AVCODEC_DECODE_AUDIO3)
     ADD_DEFINITIONS(-DHAVE_AVCODEC_DECODE_AUDIO3)
   ENDIF(HAVE_AVCODEC_DECODE_AUDIO3)
+  IF(HAVE_AVCODEC_DECODE_AUDIO4)
+    ADD_DEFINITIONS(-DHAVE_AVCODEC_DECODE_AUDIO4)
+  ENDIF(HAVE_AVCODEC_DECODE_AUDIO4)
+  IF(HAVE_AVIO_ALLOC_CONTEXT)
+    ADD_DEFINITIONS(-DHAVE_AVIO_ALLOC_CONTEXT)
+  ENDIF(HAVE_AVIO_ALLOC_CONTEXT)
   ADD_DEFINITIONS(-DENABLE_LIBAVCODEC)
 ENDIF(ENABLE_LIBAVCODEC)
 
@@ -297,26 +314,3 @@
 INCLUDE_DIRECTORIES(${GLIBMM_INCLUDE_DIRS})
 pkg_check_modules(GTK REQUIRED gtk+-2.0)
 
-INCLUDE_DIRECTORIES(${LLVM_INCLUDE_DIR})
-INCLUDE_DIRECTORIES(${ZLIB_INCLUDE_DIR})
-INCLUDE_DIRECTORIES(${FREETYPE_INCLUDE_DIRS})
-IF(ENABLE_GLES2)
-	INCLUDE_DIRECTORIES(${GLES2_INCLUDE_DIRS})
-ELSE()
-	INCLUDE_DIRECTORIES(${OPENGL_INCLUDE_DIR})
-	INCLUDE_DIRECTORIES(${GLEW_INCLUDE_DIR})
-ENDIF(ENABLE_GLES2)
-INCLUDE_DIRECTORIES(${PCRE_INCLUDE_DIR})
-INCLUDE_DIRECTORIES(${JPEG_INCLUDE_DIR})
-INCLUDE_DIRECTORIES(${XMLPP_INCLUDE_DIRS})
-INCLUDE_DIRECTORIES(${CAIRO_INCLUDE_DIRS})
-INCLUDE_DIRECTORIES(${GLIB_INCLUDE_DIRS})
-INCLUDE_DIRECTORIES(${GTK_INCLUDE_DIRS})
-
-IF(ENABLE_LIBAVCODEC)
-  INCLUDE_DIRECTORIES(${FFMPEG_INCLUDE_DIRS})
-  SET(OPTIONAL_LIBRARIES ${OPTIONAL_LIBRARIES} ${FFMPEG_LIBRARIES})
-ENDIF(ENABLE_LIBAVCODEC)	
-
-IF(CMAKE_COMPILER_IS_GNUCC)
-  IF(MINGW)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #**************************************************************************
 #    Lightspark, a free flash player implementation
 #
-#    Copyright (C) 2010-2011  Alessandro Pignotti <a.pignotti@sssup.it>
+#    Copyright (C) 2010-2012  Alessandro Pignotti <a.pignotti@sssup.it>
 #    Copyright (C) 2010  Giacomo Spigler <g.spigler@sssup.it>
 #
 #    This program is free software: you can redistribute it and/or modify
@@ -23,11 +23,13 @@
   asobject.cpp
   compat.cpp
   logger.cpp
+  memory_support.cpp
   swf.cpp
   swftypes.cpp
   thread_pool.cpp
   threading.cpp
   timer.cpp
+  tiny_string.cpp
   backends/audio.cpp
   backends/builtindecoder.cpp
   backends/config.cpp
@@ -44,6 +46,7 @@
   backends/rtmputils.cpp
   backends/security.cpp
   backends/urlutils.cpp
+  backends/xml_support.cpp
   parsing/amf3_generator.cpp
   parsing/config.cpp
   parsing/crossdomainpolicy.cpp
@@ -58,7 +61,13 @@
   scripting/abc_opcodes.cpp
   scripting/abctypes.cpp
   scripting/flash/accessibility/flashaccessibility.cpp
+  scripting/flash/desktop/flashdesktop.cpp
+  scripting/flash/display/BitmapContainer.cpp
+  scripting/flash/display/BitmapData.cpp
+  scripting/flash/display/DisplayObject.cpp
+  scripting/flash/display/IBitmapDrawable.cpp
   scripting/flash/display/flashdisplay.cpp
+  scripting/flash/display/TokenContainer.cpp
   scripting/flash/events/flashevents.cpp
   scripting/flash/external/ExternalInterface.cpp
   scripting/flash/filters/flashfilters.cpp
@@ -77,7 +86,11 @@
   scripting/toplevel/Boolean.cpp
   scripting/toplevel/Date.cpp
   scripting/toplevel/Error.cpp
+  scripting/toplevel/Integer.cpp
   scripting/toplevel/Math.cpp
+  scripting/toplevel/Number.cpp
+  scripting/toplevel/RegExp.cpp
+  scripting/toplevel/UInteger.cpp
   scripting/toplevel/Vector.cpp
   scripting/toplevel/XML.cpp
   scripting/toplevel/XMLList.cpp
@@ -120,7 +133,7 @@
 
 TARGET_LINK_LIBRARIES(spark ${CAIRO_LIBRARIES} ${ZLIB_LIBRARIES}
 	${Boost_LIBRARIES} ${LLVM_LIBS_CORE} ${LLVM_LIBS_JIT} ${LLVM_LDFLAGS}
-	${OPTIONAL_LIBRARIES} ${GTK_LIBRARIES} ${FREETYPE_LIBRARIES} ${JPEG_LIBRARIES}
+	${OPTIONAL_LIBRARIES} ${GTK_LIBRARIES} ${FREETYPE_LIBRARIES} ${JPEG_LIBRARIES} ${PNG_LIBRARIES}
 	${PCRE_LIBRARIES} ${GLIBMM_LIBRARIES} ${GMODULE_LIBRARIES}
 	${XMLPP_LIBRARIES} ${CMAKE_DL_LIBS} ${EXTRA_LIBS_LIBRARIES}
 	${X11_LIBRARIES})
@@ -149,7 +162,6 @@
   PACK_EXECUTABLE(lightspark)
   INSTALL(FILES ${PROJECT_SOURCE_DIR}/src/lightspark.frag DESTINATION ${LSDATADIR})
   INSTALL(FILES ${PROJECT_SOURCE_DIR}/src/lightspark.vert DESTINATION ${LSDATADIR})
-  INSTALL(FILES ${PROJECT_SOURCE_DIR}/src/lightspark-blitter.vert DESTINATION ${LSDATADIR})
   INSTALL(TARGETS lightspark RUNTIME DESTINATION ${BINDIR})
   IF(UNIX)
     INSTALL(FILES ${PROJECT_SOURCE_DIR}/docs/man/lightspark.1 DESTINATION share/man/man1)

=== debian/changelog ===
lightspark (0.6.0.1-2build1) quantal; urgency=low

  * No-change rebuild for libglew1.7 -> libglew1.8 transition.

 -- Ilya Barygin <randomaction@ubuntu.com>  Sat, 08 Sep 2012 18:56:23 +0400

lightspark (0.6.0.1-2) unstable; urgency=low

  * Cherry-pick upstream f1675d6 'Fix handling of resizing'.

 -- Didier Raboud <odyx@debian.org>  Thu, 14 Jun 2012 19:54:28 +0200

lightspark (0.6.0.1-1) unstable; urgency=low

  * New 0.6.0.1 upstream release.

 -- Didier Raboud <odyx@debian.org>  Sun, 10 Jun 2012 15:12:49 +0200

lightspark (0.5.7-2) unstable; urgency=low

  * Drop now-obsolete lintian override.
  * Enable RTMP support. It was supposed to be enabled by default since
    0.5.4 but wasn't. (Closes: #647149)

 -- Didier Raboud <odyx@debian.org>  Mon, 21 May 2012 10:06:50 +0200

lightspark (0.5.7-1) unstable; urgency=low

  * New 0.5.7 upstream release.
  * Bump debhelper Build-Depends to 9.

 -- Didier Raboud <odyx@debian.org>  Wed, 16 May 2012 13:20:28 +0200

lightspark (0.5.6-1) unstable; urgency=low

  * New 0.5.6 upstream release.
    - Build-Depends: add libpng-dev.
  * Bump Standards-Version to 3.9.3 without changes needed.

 -- Didier Raboud <odyx@debian.org>  Thu, 12 Apr 2012 16:57:45 +0200

=== debian/control ===
--- 
+++ 
@@ -3,13 +3,13 @@
 Priority: optional
 Maintainer: Debian Flash Maintainers <pkg-flash-devel@lists.alioth.debian.org>
 Uploaders: Didier Raboud <odyx@debian.org>
-Build-Depends: debhelper (>= 8.9.0~),
+Build-Depends: debhelper (>= 9),
   cmake,
   nasm,
   llvm-3.0-dev,
   libcurl4-gnutls-dev,
   zlib1g-dev,
-  libgles2-mesa-dev,
+  libgl1-mesa-dev,
   libpcre3-dev,
   libavutil-dev,
   libx11-dev,
@@ -22,11 +22,12 @@
   libavcodec-dev,
   libavformat-dev,
   libgtk2.0-dev,
+  libpng-dev,
   libjpeg-dev,
   librtmp-dev,
   libsdl1.2-dev,
   libxml++2.6-dev (>= 2.33.1),
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 Homepage: http://lightspark.sf.net
 Vcs-Git: git://git.debian.org/pkg-flash/lightspark.git
 Vcs-Browser: http://git.debian.org/?p=pkg-flash/lightspark.git

## lightspark 0.7.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -24,9 +24,9 @@
 # Name & Version
 PROJECT(LIGHTSPARK)
 SET(MAJOR_VERSION "0")
-SET(MINOR_VERSION "6")
+SET(MINOR_VERSION "7")
 SET(PATCH_VERSION "0")
-SET(SUBPATCH_VERSION "1")
+SET(SUBPATCH_VERSION "0")
 
 IF(EXISTS "${CMAKE_SOURCE_DIR}/.git/")
 	SET(GIT_VERSION "-git")
@@ -246,6 +246,10 @@
 INCLUDE(FindPNG REQUIRED)
 pkg_check_modules(XMLPP REQUIRED libxml++-2.6>=2.33.1)
 
+pkg_check_modules(LZMA REQUIRED liblzma)
+INCLUDE_DIRECTORIES(${LZMA_INCLUDE_DIRS})
+SET(OPTIONAL_LIBRARIES ${OPTIONAL_LIBRARIES} ${LZMA_LIBRARIES})
+
 IF(XMLPP_FOUND AND NOT(XMLPP_VERSION VERSION_LESS 2.35.1))
   ADD_DEFINITIONS(-DXMLPP_2_35_1)
 ENDIF(XMLPP_FOUND AND NOT(XMLPP_VERSION VERSION_LESS 2.35.1))
@@ -253,6 +257,9 @@
 find_package(Boost COMPONENTS filesystem system REQUIRED)
 if(Boost_FOUND)
   INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIRS})
+  #Without BOOST_MULTI_INDEX_DISABLE_SERIALIZATION, it will indirectly include
+  #windows.h and pollute our namespace
+  ADD_DEFINITIONS(-DBOOST_MULTI_INDEX_DISABLE_SERIALIZATION)
 ENDIF(Boost_FOUND) 
 
 pkg_check_modules(CAIRO REQUIRED cairo pangocairo)
@@ -289,6 +296,11 @@
   CHECK_FUNCTION_EXISTS(avcodec_decode_audio3 HAVE_AVCODEC_DECODE_AUDIO3)
   CHECK_FUNCTION_EXISTS(avcodec_decode_audio4 HAVE_AVCODEC_DECODE_AUDIO4)
   CHECK_FUNCTION_EXISTS(avio_alloc_context HAVE_AVIO_ALLOC_CONTEXT)
+  CHECK_FUNCTION_EXISTS(avcodec_alloc_context3 HAVE_AVCODEC_ALLOC_CONTEXT3)
+  CHECK_FUNCTION_EXISTS(avcodec_open2 HAVE_AVCODEC_OPEN2)
+  CHECK_FUNCTION_EXISTS(avformat_close_input HAVE_AVFORMAT_CLOSE_INPUT)
+  CHECK_FUNCTION_EXISTS(avformat_find_stream_info HAVE_AVFORMAT_FIND_STREAM_INFO)
+  
   SET(CMAKE_REQUIRED_FLAGS)
   SET(CMAKE_REQUIRED_INCLUDES)
   SET(CMAKE_REQUIRED_LIBRARIES)
@@ -297,20 +309,3 @@
   ENDIF(HAVE_AVCODEC_DECODE_VIDEO2)
   IF(HAVE_AVCODEC_DECODE_AUDIO3)
     ADD_DEFINITIONS(-DHAVE_AVCODEC_DECODE_AUDIO3)
-  ENDIF(HAVE_AVCODEC_DECODE_AUDIO3)
-  IF(HAVE_AVCODEC_DECODE_AUDIO4)
-    ADD_DEFINITIONS(-DHAVE_AVCODEC_DECODE_AUDIO4)
-  ENDIF(HAVE_AVCODEC_DECODE_AUDIO4)
-  IF(HAVE_AVIO_ALLOC_CONTEXT)
-    ADD_DEFINITIONS(-DHAVE_AVIO_ALLOC_CONTEXT)
-  ENDIF(HAVE_AVIO_ALLOC_CONTEXT)
-  ADD_DEFINITIONS(-DENABLE_LIBAVCODEC)
-ENDIF(ENABLE_LIBAVCODEC)
-
-pkg_check_modules(GLIB REQUIRED glib-2.0)
-pkg_check_modules(GTHREAD REQUIRED gthread-2.0)
-pkg_check_modules(GMODULE REQUIRED gmodule-2.0)
-pkg_check_modules(GLIBMM REQUIRED glibmm-2.4)
-INCLUDE_DIRECTORIES(${GLIBMM_INCLUDE_DIRS})
-pkg_check_modules(GTK REQUIRED gtk+-2.0)
-

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -20,6 +20,7 @@
 
 # liblightspark.so sources
 SET(LIBSPARK_SOURCES 
+  allclasses.cpp
   asobject.cpp
   compat.cpp
   logger.cpp
@@ -57,7 +58,9 @@
   parsing/textfile.cpp
   scripting/abc.cpp
   scripting/abc_codesynt.cpp
+  scripting/abc_fast_interpreter.cpp
   scripting/abc_interpreter.cpp
+  scripting/abc_optimizer.cpp
   scripting/abc_opcodes.cpp
   scripting/abctypes.cpp
   scripting/flash/accessibility/flashaccessibility.cpp
@@ -74,11 +77,14 @@
   scripting/flash/geom/flashgeom.cpp
   scripting/flash/media/flashmedia.cpp
   scripting/flash/net/flashnet.cpp
+  scripting/flash/net/URLRequestHeader.cpp
   scripting/flash/net/URLStream.cpp
+  scripting/flash/net/XMLSocket.cpp
   scripting/flash/errors/flasherrors.cpp
   scripting/flash/sensors/flashsensors.cpp
   scripting/flash/system/flashsystem.cpp
   scripting/flash/text/flashtext.cpp
+  scripting/flash/text/flashtextengine.cpp
   scripting/flash/utils/flashutils.cpp
   scripting/flash/xml/flashxml.cpp
   scripting/toplevel/Array.cpp

=== src/plugin/CMakeLists.txt ===
#**************************************************************************
#    Lightspark, a free flash player implementation
#
#    Copyright (C) 2010  Giacomo Spigler <g.spigler@sssup.it>
#    Copyright (C) 2010-2012  Alessandro Pignotti <a.pignotti@sssup.it>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
#**************************************************************************

# Dependencies
INCLUDE_DIRECTORIES("include")
INCLUDE_DIRECTORIES("..")
INCLUDE_DIRECTORIES("include/npapi")

INCLUDE_DIRECTORIES(${GTK_INCLUDE_DIRS})
IF(UNIX)
	ADD_DEFINITIONS(-DMOZ_X11)
	ADD_DEFINITIONS(-DXP_UNIX)
ELSE()
	ADD_DEFINITIONS(-DXP_WIN)
ENDIF(UNIX)

# Firefox plugin target
SET(PLUGIN_SOURCES ${PLUGIN_SOURCES}
	np_entry.cpp
	npn_gate.cpp
	npp_gate.cpp
	plugin.cpp
	npscriptobject.cpp)

IF(WIN32)
	SET(PLUGIN_SOURCES ${PLUGIN_SOURCES} plugin.rc plugin.def)
ENDIF(WIN32)

ADD_LIBRARY(lightsparkplugin MODULE ${PLUGIN_SOURCES})

TARGET_LINK_LIBRARIES(lightsparkplugin spark)

#With STATICDEPS, all deps are compiled into spark
IF(NOT STATICDEPS)
  TARGET_LINK_LIBRARIES(lightsparkplugin spark ${X11_LIBRARIES} ${GLIBMM_LIBRARIES})
ENDIF()

IF(WIN32)
  #For win32 firefox, plugins have to start with 'np'
  SET_TARGET_PROPERTIES(lightsparkplugin PROPERTIES OUTPUT_NAME nplightsparkplugin PREFIX "")
  SET_TARGET_PROPERTIES(lightsparkplugin PROPERTIES LINK_FLAGS "-Wl,--enable-stdcall-fixup")
ENDIF()

PACK_LIBRARY(lightsparkplugin)
INSTALL(TARGETS lightsparkplugin DESTINATION ${PLUGIN_DIRECTORY})

=== debian/changelog ===
lightspark (0.7.0-1build1) raring; urgency=low

  * Rebuild for the libglew1.9 -> libglew1.8 un-transition.

 -- Adam Conrad <adconrad@ubuntu.com>  Sun, 02 Dec 2012 03:47:10 -0700

lightspark (0.7.0-1) experimental; urgency=low

  * New 0.7.0 upstream version.
    - Drop patches, all backported from upstream.
    - Add liblzma-dev as Build-Depend.
    - Bump library version in common.shlibs.

  * Make lightspark-common depend on fonts-liberation instead of ttf-
    liberation. (Closes: #692243)

 -- Didier Raboud <odyx@debian.org>  Sat, 10 Nov 2012 22:44:59 +0100

=== debian/control ===
--- 
+++ 
@@ -27,6 +27,7 @@
   librtmp-dev,
   libsdl1.2-dev,
   libxml++2.6-dev (>= 2.33.1),
+  liblzma-dev,
 Standards-Version: 3.9.3
 Homepage: http://lightspark.sf.net
 Vcs-Git: git://git.debian.org/pkg-flash/lightspark.git
@@ -74,7 +75,7 @@
 
 Package: lightspark-common
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, ttf-liberation
+Depends: ${shlibs:Depends}, ${misc:Depends}, fonts-liberation
 Recommends: pulseaudio
 Description: High-performance SWF player - common data
  Lightspark is a free Flash player for Linux which aims for high-performance

## lightspark 0.7.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,7 +25,7 @@
 PROJECT(LIGHTSPARK)
 SET(MAJOR_VERSION "0")
 SET(MINOR_VERSION "7")
-SET(PATCH_VERSION "0")
+SET(PATCH_VERSION "1")
 SET(SUBPATCH_VERSION "0")
 
 IF(EXISTS "${CMAKE_SOURCE_DIR}/.git/")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -86,6 +86,7 @@
   scripting/flash/text/flashtext.cpp
   scripting/flash/text/flashtextengine.cpp
   scripting/flash/utils/flashutils.cpp
+  scripting/flash/ui/Keyboard.cpp
   scripting/flash/xml/flashxml.cpp
   scripting/toplevel/Array.cpp
   scripting/toplevel/ASString.cpp

=== debian/changelog ===
lightspark (0.7.1-1build1) saucy; urgency=low

  * No change rebuild for Boost 1.53 transition.

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Fri, 26 Apr 2013 19:18:43 +0100

lightspark (0.7.1-1) experimental; urgency=low

  * New 0.7.1 upstream version
    - Fixes for YouTube
    - Support keyboard press and release events
    - Support mouse wheel events and other mouse event improvements
    - Support LLVM 3.2
    - Implemented hit testing of DisplayObjects
    - Parse JPEG images embedded in DefineBits tags
    - Parse RGB15 and paletted images in DefineBitsLossless tags
    - Improved XML support

  * Bump Standards-Version to 3.9.4 without changes needed.
  * Update homepage to GitHub

 -- Didier Raboud <odyx@debian.org>  Fri, 28 Dec 2012 10:49:31 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: lightspark
 Section: utils
 Priority: optional
-Maintainer: Debian Flash Maintainers <pkg-flash-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Flash Maintainers <pkg-flash-devel@lists.alioth.debian.org>
 Uploaders: Didier Raboud <odyx@debian.org>
 Build-Depends: debhelper (>= 9),
   cmake,
@@ -28,8 +29,8 @@
   libsdl1.2-dev,
   libxml++2.6-dev (>= 2.33.1),
   liblzma-dev,
-Standards-Version: 3.9.3
-Homepage: http://lightspark.sf.net
+Standards-Version: 3.9.4
+Homepage: http://lightspark.github.com/
 Vcs-Git: git://git.debian.org/pkg-flash/lightspark.git
 Vcs-Browser: http://git.debian.org/?p=pkg-flash/lightspark.git
